<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Silent Refresh</title>
</head>
<body>
<script>
  var checks = [/[\?|&|#]code=/, /[\?|&|#]error=/, /[\?|&|#]token=/, /[\?|&|#]id_token=/];

  function isResponse(str) {
    if (!str) return false;
    for (var i = 0; i < checks.length; i++) {
      if (str.match(checks[i])) return true;
    }
    return false;
  }

  const message = isResponse(location.hash) ? location.hash : '#' + location.search;

  console.log("Silent refresh iframe is posting to the parent application, message:", message);

  if (window.parent && window.parent !== window) {
    // if loaded as an iframe during silent refresh
    window.parent.postMessage(message, location.origin);
  } else if (window.opener && window.opener !== window) {
    // if loaded as a popup during initial login
    window.opener.postMessage(message, location.origin);
  } else {
    // last resort for a popup which has been through redirects and can't use window.opener
    localStorage.setItem('auth_hash', message);
    localStorage.removeItem('auth_hash');
  }
</script>
</body>
</html>
